<template>
  <section class="breadcrumb-wrap">
    <span class="breadcrumb-tips">您的位置：</span>
    <el-breadcrumb class="app-breadcrumb" separator-class="el-icon-arrow-right">
      <transition-group name="breadcrumb">
        <el-breadcrumb-item v-for="(item, index) in levelList" :key="item.path">
          <span v-if="item.redirect === 'noRedirect' || index == levelList.length - 1" class="no-redirect">{{ item.meta.title }}</span>
          <a v-else @click.prevent="handleLink(item)">{{ item.meta.title }}</a>
        </el-breadcrumb-item>
      </transition-group>
    </el-breadcrumb>
  </section>
</template>

<script>
export default {
  data() {
    return {
      levelList: null
    }
  },
  watch: {
    $route(route) {
      // if you go to the redirect page, do not update the breadcrumbs
      if (route.path.startsWith('/redirect/')) {
        return
      }
      this.getBreadcrumb()
    }
  },
  created() {
    this.getBreadcrumb()
  },
  methods: {
    getBreadcrumb() {
      // only show routes with meta.title
      let matched = this.$route.matched.filter((item) => item.meta && item.meta.title)
      const first = matched[0]

      if (!this.isDashboard(first)) {
        matched = [{ path: '/index', meta: { title: '首页' }}].concat(matched)
      }

      this.levelList = matched.filter((item) => item.meta && item.meta.title && item.meta.breadcrumb !== false)
    },
    isDashboard(route) {
      const name = route && route.name
      if (!name) {
        return false
      }
      return name.trim() === 'Index'
    },
    handleLink(item) {
      const { redirect, path } = item
      if (redirect) {
        this.$router.push(redirect)
        return
      }
      this.$router.push(path)
    }
  }
}
</script>

<style lang="scss" scoped>
.app-breadcrumb {
  margin-left: 0 !important;
  > span {
    .el-breadcrumb__item:last-child .no-redirect {
      color: #4886f8;
    }
  }
  ::v-deep .el-breadcrumb__inner a {
    color: #959da6;
    font-weight: 400 !important;
    font-family: PingFangSC;
    &:hover {
      color: #4886f8;
    }
  }
}
.app-breadcrumb.el-breadcrumb {
  display: inline-block;
  font-size: 14px;
  line-height: 50px;
  margin-left: 8px;

  .no-redirect {
    font-family: PingFangSC;
    color: #959da6;
    font-size: 14px;
    font-weight: 400;
    letter-spacing: 0;
    cursor: text;
  }
}
.breadcrumb-wrap {
  display: flex;
  align-items: center;
  justify-content: center;
  .breadcrumb-tips {
    color: #666666;
    font-size: 14px;
    font-weight: 400;
  }
}
</style>
